## nootka 1.4.7

=== CMakeLists.txt ===
########################################################################
# MAIN CMAKE FILE FOR Nootka
########################################################################

cmake_minimum_required(VERSION 2.8.12)

project(nootka)

SET(Nootka_VERSION_MAJOR  "1")
SET(Nootka_VERSION_MINOR  "4")
SET(Nootka_VERSION_PATCH  "7")

SET(Nootka_VERSION       "${Nootka_VERSION_MAJOR}.${Nootka_VERSION_MINOR}")
SET(Nootka_VERSION_FULL  "${Nootka_VERSION}.${Nootka_VERSION_PATCH}")
message(STATUS "
${PROJECT_NAME}-${Nootka_VERSION_FULL}
" )


set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/src)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/src)

if (UNIX AND NOT APPLE) # config with version number is generated once on developer platform
configure_file(${CMAKE_SOURCE_DIR}/src/nootkaconfig.h.in ${CMAKE_SOURCE_DIR}/src/libs/core/nootkaconfig.h)
endif (UNIX AND NOT APPLE)

if (APPLE)
  install( CODE "
    execute_process(
      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_INSTALL_PREFIX}/nootka.app/Contents)
    ")
endif (APPLE)

if(WIN32)
  set(PACKAGE_ARCHITECTURE x86)
endif(WIN32)
if(APPLE)
  set(PACKAGE_ARCHITECTURE x86_64)
endif(APPLE)

if(NOT PACKAGE_ARCHITECTURE)
   find_program(DPKG_CMD dpkg)
   if(NOT DPKG_CMD)
      find_program(RPM_CMD rpm)
      if(NOT RPM_CMD)
        execute_process(COMMAND uname -m
          OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE
        )
      else(NOT RPM_CMD)
        execute_process(COMMAND "${RPM_CMD}" --eval %_target_cpu
          OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE 
        )
        set(RPM_CMD_FOUND TRUE)
      endif(NOT RPM_CMD)
   else(NOT DPKG_CMD)
      execute_process(COMMAND "${DPKG_CMD}" --print-architecture
        OUTPUT_VARIABLE PACKAGE_ARCHITECTURE
        OUTPUT_STRIP_TRAILING_WHITESPACE
      )
      add_definitions(-D_FORTIFY_SOURCE=2) # for lintian DEB_BUILD_HARDENING_FORTIFY
   endif(NOT DPKG_CMD)
endif(NOT PACKAGE_ARCHITECTURE)
message(STATUS "Architecture is ${PACKAGE_ARCHITECTURE}")
if (NOT DPKG_CMD)
    unset(DPKG_CMD)
endif (NOT DPKG_CMD)


add_subdirectory(src)


###########################################################################
#INSTALLATION
###########################################################################

if(WIN32)
    set(INS_PREF ".")
else(WIN32)
  if (APPLE)
    set(INS_PREF "nootka.app/Contents/Resources")
  else(APPLE)
    set(INS_PREF "share/nootka")
  endif(APPLE)
endif(WIN32)


if(APPLE)
  install( CODE "
      execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/packaging/mac/install.sh ${CMAKE_INSTALL_PREFIX} ${SOUNDTOUCH_LIBRARY} ${FFTW3_LIBRARIES} ${VORBIS_LIBRARIES} )
  " )
	install(FILES "${CMAKE_SOURCE_DIR}/picts/nootka.icns" DESTINATION "${INS_PREF}") # icns for mac
	install(FILES "${CMAKE_SOURCE_DIR}/picts/nootka-levels.icns" DESTINATION "${INS_PREF}")
	install(FILES "${CMAKE_SOURCE_DIR}/picts/nootka-exam.icns" DESTINATION "${INS_PREF}")
endif(APPLE)


install(FILES changes DESTINATION "${INS_PREF}")
file(GLOB ICONS_PNG "${CMAKE_CURRENT_SOURCE_DIR}/picts/*.png") #png-s for all
install(FILES ${ICONS_PNG} DESTINATION "${INS_PREF}/picts")
install(DIRECTORY fonts DESTINATION "${INS_PREF}")

file(GLOB langs "${CMAKE_CURRENT_SOURCE_DIR}/lang/*.qm")
if(APPLE OR WIN32)
  find_package(Qt5Core)
  get_target_property(QtCore_location_Release Qt5::Core LOCATION_Release)
  get_filename_component(QT_BINARY_DIR "${QtCore_location_Release}" DIRECTORY)
  if (WIN32)
    set(QT_TRANSLATIONS_DIR "${QT_BINARY_DIR}/../translations")
  else (WIN32)
    set(QT_TRANSLATIONS_DIR "${QT_BINARY_DIR}/../../translations")
  endif (WIN32)
	install(FILES gpl DESTINATION "${INS_PREF}")
 LIST(APPEND langs
   "${QT_TRANSLATIONS_DIR}/qtbase_cs.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_de.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_es.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_fr.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_hu.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_pl.qm"
   "${QT_TRANSLATIONS_DIR}/qtbase_ru.qm"
#    "${QT_TRANSLATIONS_DIR}/qtbase_sl.qm"
      # So far not provided by Qt
      #"${CMAKE_CURRENT_SOURCE_DIR}/lang/qtbase/qtbase_sl.qm"

  )
endif(APPLE OR WIN32)

install(FILES ${langs} DESTINATION "${INS_PREF}/lang")

if(APPLE)
  file(GLOB MIME_TRANS "${CMAKE_CURRENT_SOURCE_DIR}/packaging/mac/*.lproj" )
  install(DIRECTORY ${MIME_TRANS} DESTINATION ${INS_PREF})
endif(APPLE)


file(GLOB snds "${CMAKE_CURRENT_SOURCE_DIR}/sounds/*.ogg")
install(FILES ${snds} DESTINATION "${INS_PREF}/sounds")

# files related with Linux (mime, desktop entry, icons)
if(UNIX AND NOT APPLE)
    install(FILES mime/nootka.desktop DESTINATION share/applications)
    install(FILES mime/nootka.appdata.xml DESTINATION share/metainfo)
    install(FILES mime/nootka.xml DESTINATION share/mime/packages)
    if (NOT DPKG_CMD) # deb packager doesn't accept symbolic links
			install(FILES gpl DESTINATION "${INS_PREF}") # no gpl for Debian-s - they have copyright instead
    endif (NOT DPKG_CMD)
  # Icons in standard location
    install(FILES picts/hicolor/16x16/apps/nootka.png DESTINATION share/icons/hicolor/16x16/apps/)
    install(FILES picts/hicolor/24x24/apps/nootka.png DESTINATION share/icons/hicolor/24x24/apps/)
    install(FILES picts/hicolor/32x32/apps/nootka.png DESTINATION share/icons/hicolor/32x32/apps/)
    install(FILES picts/hicolor/48x48/apps/nootka.png DESTINATION share/icons/hicolor/48x48/apps/)
    install(FILES picts/hicolor/64x64/apps/nootka.png DESTINATION share/icons/hicolor/64x64/apps/)
    install(FILES picts/hicolor/128x128/apps/nootka.png DESTINATION share/icons/hicolor/128x128/apps/)
    install(FILES picts/hicolor/256x256/apps/nootka.png DESTINATION share/icons/hicolor/256x256/apps/)
    install(FILES picts/nootka.png DESTINATION share/icons/hicolor/512x512/apps/)
    install(FILES picts/hicolor/16x16/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/16x16/mimetypes/)
    install(FILES picts/hicolor/24x24/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/24x24/mimetypes/)
    install(FILES picts/hicolor/32x32/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/32x32/mimetypes/)
    install(FILES picts/hicolor/48x48/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/48x48/mimetypes/)
    install(FILES picts/hicolor/64x64/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/64x64/mimetypes/)
    install(FILES picts/hicolor/128x128/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/128x128/mimetypes/)
    install(FILES picts/nootka-exam.png DESTINATION share/icons/hicolor/256x256/mimetypes/ RENAME nootkaexam.png)
    install(FILES picts/hicolor/512x512/mimetypes/nootkaexam.png DESTINATION share/icons/hicolor/512x512/mimetypes/)
    install(FILES picts/hicolor/16x16/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/16x16/mimetypes/)
    install(FILES picts/hicolor/24x24/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/24x24/mimetypes/)
    install(FILES picts/hicolor/32x32/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/32x32/mimetypes/)
    install(FILES picts/hicolor/48x48/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/48x48/mimetypes/)
    install(FILES picts/hicolor/64x64/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/64x64/mimetypes/)
    install(FILES picts/hicolor/128x128/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/128x128/mimetypes/)
    install(FILES picts/nootka-level.png DESTINATION share/icons/hicolor/256x256/mimetypes/ RENAME nootkalevel.png)
    install(FILES picts/hicolor/512x512/mimetypes/nootkalevel.png DESTINATION share/icons/hicolor/512x512/mimetypes/)
		install( CODE "
      execute_process(COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/doc )
      execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/packaging/make-chlog.sh ${Nootka_VERSION_FULL} ${CMAKE_CURRENT_BINARY_DIR}/doc/changelog ${CMAKE_CURRENT_SOURCE_DIR})
	" )
  if (DPKG_CMD) # Debian changelog
      install(FILES "${CMAKE_CURRENT_BINARY_DIR}/doc/changelog.Debian.gz" DESTINATION share/doc/nootka RENAME changelog.gz)
  endif (DPKG_CMD)
	install(FILES copyright DESTINATION share/doc/nootka)
	install(FILES packaging/nootka.1.gz DESTINATION share/man/man1)
endif(UNIX AND NOT APPLE)

if(WIN32)
  get_filename_component(VORBIS_DIR "${VORBIS_LIBRARIES}" DIRECTORY)
  get_filename_component(MAKE_DIR "${CMAKE_RC_COMPILER}" DIRECTORY) # it works ether with make and ninja
  install(FILES picts/nootka-exam.ico picts/nootka.ico picts/nootka-levels.ico picts/pack.ico picts/logo.bmp picts/logo-left.bmp DESTINATION "${INS_PREF}/picts") #ico
  install(FILES packaging/nsis/nootka-utf8.nsi packaging/nsis/fileasoc.nsh ${CMAKE_BINARY_DIR}/nsis/NSIS.definitions.nsh DESTINATION "${INS_PREF}")
  install(FILES "${FFTW3_LIBRARIES}" "${VORBIS_LIBRARIES}" "${VORBIS_DIR}/libvorbis.dll" "${VORBIS_DIR}/libogg.dll" DESTINATION "${INS_PREF}")
endif(WIN32)

###########################################################################
# uninstall target
###########################################################################
configure_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

  add_custom_target(uninstall
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)


add_subdirectory( packaging ) # cpack rules


# Uncomment below lines if you want to build any testing executable
# add_subdirectory( tests/plugtester )
# add_subdirectory( tests/nootini )
# add_subdirectory( tests/nootoxml )

=== src/libs/main/CMakeLists.txt ===
########################################################################
# CMakeList.txt NootkaMain library
########################################################################


add_definitions(-DNOOTKACORE_LIBRARY)

include_directories( . ../core ../score ../widgets ../sound ../misc )

set(LIB_NOOTKAMAIN_SRC
  animations/tstrikedoutitem.cpp

  gui/tmainview.cpp
  gui/tmelman.cpp
  gui/ttoolbar.cpp
  gui/tmenu.cpp
  gui/tstatuslabel.cpp
  gui/tbgpixmap.cpp

  guitar/tfingerboard.cpp
  guitar/tguitarview.cpp

  notename/tnotename.cpp
  notename/tnotenamelabel.cpp
  notename/tnametip.cpp

  score/tmainscore.cpp
  score/tscoreactions.cpp

  exam/tprogresswidget.cpp
  exam/texamview.cpp
  exam/trandmelody.cpp
)


add_library(NootkaMain SHARED ${LIB_NOOTKAMAIN_SRC} )
target_link_libraries(NootkaMain Qt5::Widgets NootkaMisc NootkaSound )

if(UNIX AND NOT APPLE) 	# Linux path for Nootka binary
  install(TARGETS NootkaMain DESTINATION lib/nootka)
else(UNIX AND NOT APPLE)
  if(WIN32) 			# Windows
    install(TARGETS NootkaMain DESTINATION .)
  else(WIN32) 			# MacOs
    install(TARGETS NootkaMain DESTINATION "${CMAKE_INSTALL_PREFIX}/nootka.app/Contents/Frameworks")
  endif(WIN32)
endif(UNIX AND NOT APPLE)

=== src/libs/sound/CMakeLists.txt ===
########################################################################
# CMakeList.txt NootkaSound library
########################################################################

###########################################################################
########   Looking for fftw3
###########################################################################
IF(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)
  set(FFTW3_FOUND TRUE)
ELSE(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)
  find_path(FFTW3_INCLUDE_DIR
    NAMES
      fftw3.h
    PATHS
      /usr/include
      /usr/local/include
      /opt/local/include
      /sw/include
      ${CMAKE_SOURCE_DIR}/fftw
      ${CMAKE_SOURCE_DIR}/../fftw
      ${CMAKE_BINARY_DIR}/fftw
      ${CMAKE_BINARY_DIR}/../fftw
  )
  IF(WIN32)
    find_library(FFTW3_LIBRARY
      NAMES
        libfftw3f-3.dll
      PATHS
        ${CMAKE_SOURCE_DIR}/fftw
        ${CMAKE_SOURCE_DIR}/../fftw
          ${CMAKE_BINARY_DIR}/fftw
        ${CMAKE_BINARY_DIR}/../fftw
    )
  ELSE(WIN32)
    find_library(FFTW3_LIBRARY
      NAMES
        fftw3f
      PATHS
        /usr/lib
        /usr/lib64
        /usr/local/lib
        /opt/local/lib
        /sw/lib
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
  )
  ENDIF(WIN32)

  set(FFTW3_INCLUDE_DIRS "${FFTW3_INCLUDE_DIR}" CACHE STRING "FFTW include directory")
  set(FFTW3_LIBRARIES "${FFTW3_LIBRARY}" CACHE STRING "FFTW library path")

  IF(FFTW3_INCLUDE_DIRS AND FFTW3_LIBRARIES)
     set(FFTW3_FOUND TRUE)
  ENDIF(FFTW3_INCLUDE_DIRS AND FFTW3_LIBRARIES)

  IF(FFTW3_FOUND)
      message(STATUS "Fftw3 was Found in:\n${FFTW3_LIBRARIES}\nheaders are in: ${FFTW3_INCLUDE_DIRS}")
  ELSE(FFTW3_FOUND)
      message(FATAL_ERROR "Could not find Fftw3\nTry call cmake with args:\n-DFFTW3_LIBRARIES=/path_to/libfftw3.la(dll) -DFFTW3_INCLUDE_DIRS=/path_to_dir_with/fftw3.h\nor put those files in build dir or source dir")
  ENDIF(FFTW3_FOUND)

ENDIF(FFTW3_LIBRARIES AND FFTW3_INCLUDE_DIRS)

include_directories(${FFTW3_INCLUDE_DIRS})


###########################################################################
########   Looking for Ogg Vorbis (ogg decoder)
###########################################################################
IF(VORBIS_LIBRARIES AND OGG_INCLUDE_DIRS AND VORBIS_INCLUDE_DIRS)
  set(OGG_FOUND TRUE)
ELSE(VORBIS_LIBRARIES AND OGG_INCLUDE_DIRS AND VORBIS_INCLUDE_DIRS)
  find_path(VORBIS_INCLUDE_DIR
    NAMES
      "vorbis/vorbisfile.h"
    PATHS
      /usr/include
      /usr/local/include
      /opt/local/include
      /sw/include
      ${CMAKE_SOURCE_DIR}/../libvorbis/include
      ${CMAKE_SOURCE_DIR}/libvorbis/include
      ${CMAKE_BINARY_DIR}/../libvorbis/include
  )
  find_path(OGG_INCLUDE_DIR
    NAMES
      "ogg/ogg.h"
    PATHS
      /usr/include
      /usr/local/include
      /opt/local/include
      /sw/include
      ${CMAKE_SOURCE_DIR}/libogg/include
      ${CMAKE_SOURCE_DIR}}/../libogg/include
      ${CMAKE_BINARY_DIR}/libogg/include
      ${CMAKE_BINARY_DIR}/../libogg/include
  )
  IF(WIN32)
    find_library(VORBIS_LIBRARY
      NAMES
        libvorbisfile.dll
      PATHS
      ${CMAKE_SOURCE_DIR}/vorbis-tools
      ${CMAKE_SOURCE_DIR}}/../vorbis-tools
      ${CMAKE_BINARY_DIR}/../vorbis-tools
    )
  ELSE(WIN32)
    find_library(VORBIS_LIBRARY
      NAMES
        vorbisfile
      PATHS
        /usr/lib
        /usr/lib64
        /usr/local/lib
        /opt/local/lib
        /sw/lib
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_SOURCE_DIR}}/../libvorbis/include
        ${CMAKE_CURRENT_SOURCE_DIR}
  )
  ENDIF(WIN32)

  set(VORBIS_INCLUDE_DIRS    ${VORBIS_INCLUDE_DIR} )
  set(OGG_INCLUDE_DIRS       ${OGG_INCLUDE_DIR})
  set(VORBIS_LIBRARIES       ${VORBIS_LIBRARY} CACHE STRING "Ogg vorbis library path") 

  IF(VORBIS_INCLUDE_DIRS AND OGG_INCLUDE_DIRS AND VORBIS_LIBRARIES)
     set(OGG_FOUND TRUE)
  ENDIF(VORBIS_INCLUDE_DIRS AND OGG_INCLUDE_DIRS AND VORBIS_LIBRARIES)

  IF(OGG_FOUND)
      message(STATUS "Ogg Vorbis was Found in:\n${VORBIS_LIBRARIES}\nheaders are in: ${OGG_INCLUDE_DIRS} ${VORBIS_INCLUDE_DIRS}")
  ELSE(OGG_FOUND)
      message(FATAL_ERROR "Could not find libvorbis\nTry call cmake with args:\n-DVORBIS_LIBRARIES =/path_to/libvorbisfile.so(dll) -DVORBIS_INCLUDE_DIRS=/path_to_dir_with/vorbis/vorbisfile.h\n-DOGG_INCLUDE_DIRS=/path_to_dir_with/ogg/ogg.h\nor put those files in build dir or source dir")
  ENDIF(OGG_FOUND)

ENDIF(VORBIS_LIBRARIES AND OGG_INCLUDE_DIRS AND VORBIS_INCLUDE_DIRS)

include_directories(${OGG_INCLUDE_DIRS})
include_directories(${VORBIS_INCLUDE_DIR})

###########################################################################
########   Looking for SoundTouch
###########################################################################
if (UNIX)
  IF(SOUNDTOUCH_LIBRARIES AND SOUNDTOUCH_INCLUDE_DIRS)
    set(SOUNDTOUCH_FOUND TRUE)
  ELSE(SOUNDTOUCH_LIBRARIES AND SOUNDTOUCH_INCLUDE_DIRS)
    find_path(SOUNDTOUCH_INCLUDE_DIR
          NAMES
            soundtouch/SoundTouch.h
          PATHS
            /usr/include
            /usr/local/include
            /opt/local/include
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${CMAKE_BINARY_DIR}/../soundtouch
        )
  
    find_library(SOUNDTOUCH_LIBRARY
          NAMES
            SoundTouch
          PATHS
            /usr/lib
            /usr/lib64
            /usr/local/lib
            /opt/local/lib
            /sw/lib
            ${CMAKE_BINARY_DIR}/../soundtouch
            ${CMAKE_CURRENT_SOURCE_DIR}
    )

    set(SOUNDTOUCH_INCLUDE_DIRS
      ${SOUNDTOUCH_INCLUDE_DIR}
    )
    set(SOUNDTOUCH_LIBRARIES
      ${SOUNDTOUCH_LIBRARY}
    )

    IF(SOUNDTOUCH_INCLUDE_DIRS AND SOUNDTOUCH_LIBRARIES)
      set(SOUNDTOUCH_FOUND TRUE)
    ENDIF(SOUNDTOUCH_INCLUDE_DIRS AND SOUNDTOUCH_LIBRARIES)

    IF(SOUNDTOUCH_FOUND)
        message(STATUS "SoundTouch was Found in:\n${SOUNDTOUCH_LIBRARIES}\nheaders are in: ${SOUNDTOUCH_INCLUDE_DIRS}")
    ELSE(SOUNDTOUCH_FOUND)
        message(FATAL_ERROR "Could not find SoundTouch\nTry call cmake with args:\n-DSOUNDTOUCH_LIBRARIES=/path_to/libSoundTouch.la(dll) -DSOUNDTOUCH_INCLUDE_DIRS=/path_to_dir_with/libSoundTouch.h\nor put those files in build dir or source dir")
    ENDIF(SOUNDTOUCH_FOUND)

  ENDIF(SOUNDTOUCH_LIBRARIES AND SOUNDTOUCH_INCLUDE_DIRS)
endif (UNIX)

###########################################################################
#libraries and compiler definitions for RtMidi
###########################################################################
if (APPLE)
      find_library(CoreAudio_LIB             NAMES CoreAudio)
      find_library(CoreMidi_LIB              NAMES CoreMIDI)
      find_library(CoreFoundation_LIB        NAMES CoreFoundation)
endif (APPLE)

IF(UNIX AND NOT APPLE)
  find_library(ALSA_LIBRARY
		  NAMES
			asound
		  PATHS
			/usr/lib
			/usr/lib/x86_64-linux-gnu
			/usr/local/lib
			/opt/local/lib
  )
  find_library(PTHREAD_LIBRARY
		  NAMES
			pthread
		  PATHS
			/usr/lib
			/usr/lib/x86_64-linux-gnu
			/usr/local/lib
			/opt/local/lib
  )
  mark_as_advanced(ALSA_LIBRARY PTHREAD_LIBRARY)

ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
# 	add_definitions(-D__WINDOWS_WASAPI__)
#   add_definitions(-D__WINDOWS_DS__)
#   add_definitions(-D__WINDOWS_ASIO__)
#   add_definitions(-D__WINDOWS_MM__)
#   set(WIN_LIBS winmm ole32 dsound uuid ksuser) # uuid & ksuser are required by WASAPI
ENDIF(WIN32)

if(APPLE)
  add_definitions(-D__MACOSX_CORE__)
endif(APPLE)


IF(UNIX AND NOT APPLE)
	##### PulseAudio ###########################################
      find_path(PULSE_INCLUDE_DIR
        NAMES
          pulseaudio.h
        PATHS
          /usr/include
          /usr/include/pulse
          /usr/local/include
          /opt/local/include
          /sw/include
          
      )
      if (PULSE_INCLUDE_DIR)
          find_library(PULSESIMPLE_LIBRARY
              NAMES
              pulse-simple
              PATHS
              /usr/lib
              /usr/lib/x86_64-linux-gnu
              /usr/local/lib
              /opt/local/lib
          )
          find_library(PULSEERROR_LIBRARY
              NAMES
              pulse
              PATHS
              /usr/lib
              /usr/lib/x86_64-linux-gnu
              /usr/local/lib
              /opt/local/lib
          )
      endif (PULSE_INCLUDE_DIR)
		if (PULSE_INCLUDE_DIR)
        option(ENABLE_PULSEAUDIO "Enable support for PulseAudio" ON)
    else(PULSE_INCLUDE_DIR)
        option(ENABLE_PULSEAUDIO "Enable support for PulseAudio" OFF)
        set(PULSEERROR_LIBRARY_FOUND TRUE)
        set(PULSESIMPLE_LIBRARY_FOUND TRUE)
    endif (PULSE_INCLUDE_DIR)
    
      
	##### JACK - Jack Audio Connection Kit ##############
      find_path(JACK_INCLUDE_DIR
        NAMES
          jack.h
        PATHS
          /usr/include
          /usr/include/jack
          /usr/local/include
          /opt/local/include
          /sw/include
          
      )
      if (JACK_INCLUDE_DIR)
          find_library(JACK_LIBRARY
              NAMES
              jack
              PATHS
              /usr/lib
              /usr/lib/x86_64-linux-gnu
              /usr/local/lib
              /opt/local/lib
          )
      endif (JACK_INCLUDE_DIR)
      
    if (JACK_INCLUDE_DIR)
        option(ENABLE_JACK "Enable support for JACK (Jack Audio Connection Kit)" ON)
    else (JACK_INCLUDE_DIR)    
        option(ENABLE_JACK "Enable support for JACK (Jack Audio Connection Kit)" OFF)
        set(JACK_LIBRARY_FOUND TRUE)
    endif (JACK_INCLUDE_DIR)
    
  if(ALSA_LIBRARY)
    add_definitions(-D__LINUX_ALSA__)
    message(STATUS "support for ALSA\t\t TRUE")
  else(ALSA_LIBRARY)
    message(STATUS "support for ALSA\t\t FALSE")
  endif(ALSA_LIBRARY)
  if(ENABLE_JACK AND JACK_INCLUDE_DIR)
    add_definitions(-D__UNIX_JACK__)
    include_directories(${JACK_INCLUDE_DIR})
    message(STATUS "support for JACK\t\t TRUE")
  else(ENABLE_JACK AND JACK_INCLUDE_DIR)
    message(STATUS "support for JACK\t\t FALSE")
  endif(ENABLE_JACK AND JACK_INCLUDE_DIR)
  if(ENABLE_PULSEAUDIO AND PULSE_INCLUDE_DIR)
    add_definitions(-D__LINUX_PULSE__)
    include_directories(${PULSE_INCLUDE_DIR})
    message(STATUS "support for PulseAudio\t TRUE")
  else(ENABLE_PULSEAUDIO AND PULSE_INCLUDE_DIR)
    message(STATUS "support for PulseAudio\t FALSE")
  endif(ENABLE_PULSEAUDIO AND PULSE_INCLUDE_DIR)
  
endif(UNIX AND NOT APPLE)


add_definitions(-DNOOTKASOUND_LIBRARY)

include_directories( . ../core ../score )

if (WIN32)
	include_directories( rt )
endif(WIN32)


set(LIB_NOOTKASOUND_SRC
	tabstractplayer.cpp
	tartiniparams.h
	tmidiout.cpp
	toggscale.cpp
	tpitchfinder.cpp
	taudioobject.h
	trtaudio.cpp
	tcommonlistener.cpp
	trtaudioin.cpp
	trtaudioout.cpp
	tsound.cpp
	
	tartini/analysisdata.cpp
	tartini/array1d.h
	tartini/bspline.cpp
	tartini/channel.cpp
	tartini/conversions.cpp
	tartini/fast_smooth.cpp
	tartini/large_vector.h
	tartini/mytransforms.cpp
	tartini/notedata.cpp
	tartini/SmartPtr.h
	tartini/useful.cpp
	tartini/filters/FastSmoothedAveragingFilter.cpp
	tartini/filters/Filter.h
	tartini/filters/FixedAveragingFilter.cpp
	tartini/filters/GrowingAveragingFilter.cpp
	tartini/filters/IIR_Filter.cpp
	
	widgets/tabstractsoundview.cpp
	widgets/tintonationview.cpp
	widgets/tpitchview.cpp
	widgets/tvolumeview.cpp
# 	widgets/tpcmview.cpp
)

IF(WIN32)
  add_subdirectory( rt )
  link_directories( ${CMAKE_BINARY_DIR}/src )
  set(WIN_LIBS RtAudio)

	list(APPEND LIB_NOOTKASOUND_SRC
    tasioemitter.h
# 		rt/asio.cpp
# 		rt/asiodrivers.cpp
# 		rt/asiolist.cpp
# 		rt/iasiothiscallresolver.cpp
	)
  list(APPEND LIB_NOOTKASOUND_SRC 
    stouch/SoundTouch.cpp
    stouch/TDStretch.cpp
    stouch/RateTransposer.cpp
    stouch/AAFilter.cpp
    stouch/FIRFilter.cpp 
    stouch/FIFOSampleBuffer.cpp 
    stouch/cpu_detect_x86.cpp 
    stouch/sse_optimized.cpp
    stouch/InterpolateCubic.cpp
    stouch/InterpolateLinear.cpp
    stouch/InterpolateShannon.cpp
  )
else (WIN32)
  list(APPEND LIB_NOOTKASOUND_SRC
    rt/RtAudio.cpp
    rt/RtMidi.cpp
  )
endif(WIN32)

=== src/libs/widgets/CMakeLists.txt ===
########################################################################
# CMakeList.txt NootkaWidgets library
########################################################################

include_directories( . ../core ../score )

add_definitions(-DNOOTKACORE_LIBRARY)

set(LIB_NOOTKAWIDGETS_SRC
	level/tlevelsdefs.cpp
	level/tlevelpreview.cpp
	level/tlevelselector.cpp
	level/tfixleveldialog.cpp

	widgets/tquestionaswdg.cpp
	widgets/tsettingsdialogbase.cpp
	widgets/troundedlabel.cpp
	widgets/tselectinstrument.cpp
	widgets/thelpdialogbase.cpp
)

add_library(NootkaWidgets SHARED ${LIB_NOOTKAWIDGETS_SRC} )
target_link_libraries(NootkaWidgets NootkaScore Qt5::Widgets)

if(UNIX AND NOT APPLE) 	# Linux path for Nootka library
  install(TARGETS NootkaWidgets DESTINATION lib/nootka)
else(UNIX AND NOT APPLE)
  if(WIN32) 			# Windows
    install(TARGETS NootkaWidgets DESTINATION .)
  else(WIN32) 			# MacOs
    install(TARGETS NootkaWidgets DESTINATION "${CMAKE_INSTALL_PREFIX}/nootka.app/Contents/Frameworks")
  endif(WIN32)
endif(UNIX AND NOT APPLE)

=== src/plugins/about/CMakeLists.txt ===
########################################################################
# CMakeList.txt nootka ABOUT plugin library
########################################################################


set(ABOUT_SRC
  taboutplugin.cpp
  taboutnootka.cpp
  tsupportnootka.cpp
  tdonorswidget.cpp
)


add_library(NootkaAboutPlugin SHARED ${ABOUT_SRC} )
target_link_libraries(NootkaAboutPlugin NootkaCore NootkaMisc Qt5::Widgets)

if(UNIX AND NOT APPLE) 	# Linux path for Nootka binary
  install(TARGETS NootkaAboutPlugin DESTINATION lib/nootka)
else(UNIX AND NOT APPLE)
  if(WIN32) 			# Windows
    install(TARGETS NootkaAboutPlugin DESTINATION .)
  else(WIN32) 			# MacOs
    install(TARGETS NootkaAboutPlugin DESTINATION "${CMAKE_INSTALL_PREFIX}/nootka.app/Contents/Frameworks")
  endif(WIN32)
endif(UNIX AND NOT APPLE)

=== src/plugins/wizard/CMakeLists.txt ===
########################################################################
# CMakeList.txt nootka level plugin library
########################################################################


set(WIZARD_SRC
  twizardplugin.cpp
  tfirstrunwizard.cpp
)


add_library(NootkaWizardPlugin SHARED ${WIZARD_SRC} )
target_link_libraries(NootkaWizardPlugin NootkaCore NootkaMisc Qt5::Widgets)

if(UNIX AND NOT APPLE) 	# Linux path for Nootka binary
  install(TARGETS NootkaWizardPlugin DESTINATION lib/nootka)
else(UNIX AND NOT APPLE)
  if(WIN32) 			# Windows
    install(TARGETS NootkaWizardPlugin DESTINATION .)
  else(WIN32) 			# MacOs
    install(TARGETS NootkaWizardPlugin DESTINATION "${CMAKE_INSTALL_PREFIX}/nootka.app/Contents/Frameworks")
  endif(WIN32)
endif(UNIX AND NOT APPLE)

=== src/libs/sound/rt/CMakeLists.txt ===
########################################################################
# CMakeList.txt RtAudio library for Windows build
########################################################################

cmake_minimum_required(VERSION 2.8.12)

project(RtAudio)
# Revert c++11 flag set somewhere above - ASIO won't compile with c++11
set(CMAKE_CXX_FLAGS "")

#message( ${CMAKE_CXX_FLAGS})

set(CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}../../../../)

include_directories( ../.  . )

add_definitions(-D__WINDOWS_WASAPI__)
add_definitions(-D__WINDOWS_DS__)
add_definitions(-D__WINDOWS_ASIO__)
add_definitions(-D__WINDOWS_MM__)
# set(WIN_LIBS winmm ole32 dsound uuid ksuser) # uuid & ksuser are required by WASAPI


set(LIB_RTAUDIO_SRC
  RtAudio.cpp
  RtMidi.cpp
  asio.cpp
  asiodrivers.cpp
  asiolist.cpp
  iasiothiscallresolver.cpp
  ../tasioemitter.h
)

add_library(RtAudio SHARED ${LIB_RTAUDIO_SRC} )
target_link_libraries(RtAudio Qt5::Core ${CMAKE_THREAD_LIBS_INIT} winmm ole32 dsound uuid ksuser)

install(TARGETS RtAudio DESTINATION .)

=== debian/changelog ===
nootka (1.4.7-1~mx19+1) mx; urgency=medium

  * New upstream release; build for MX Linux:
     - a few improvements for instruments other than guitar.
     - properly display answer result messages.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 29 Jun 2020 10:26:31 -0700

nootka (1.4.6-0.1~mx19+1) mx; urgency=medium

  * New upstream release; build for MX Linux.
  * Now requires Qt 5 >= 5.4.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 16 Oct 2019 15:32:08 -0700

nootka (1.4.5-0.1~mx17+1) mx; urgency=medium

  * New upstream release, build for MX 17.
  * Disable automatic dbgsym packages and bump to debhelper 10 compat to
    support the override.
  * Refresh qmaxfix.patch
  * Fix up long and short descriptions.
  * Add timidity as a Recommends.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 May 2019 08:46:28 -0700

=== debian/control ===
Source: nootka
Section: sound
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
Build-Depends:
 cmake,
 debhelper (>= 10),
 libasound2-dev,
 libfftw3-dev,
 libjack-dev,
 libpulse-dev,
 libsoundtouch-dev,
 libvorbis-dev,
 pkg-kde-tools,
 qtbase5-dev (>= 5.4)
Standards-Version: 3.9.6
Homepage: http://nootka.sourceforge.net/

Package: nootka
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: timidity
Description: application to learn classical score notation.
 Nootka is an application to learn classical score notation.
 Mostly it is for guitarists, but it can be used for ear training as well.
 .
 Features:
 numerous settings to personalize for user needs and capabilities
 natural, classical guitar sound output
 midi support for different name-callings of the notes
 scordatures
 exams with different levels
 levels creator with wide range of settings

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with=kde

override_dh_strip:
	dh_strip --no-automatic-dbgsym
